Attribute VB_Name = "Messdaten"
' Programmname: PC-DMIS Abmessungen zu Ascii Datei
' Kunde: Georg Fischer, Atlas Copco, Tyco, Allgemein etc.
'
' MRothleiter + Tbach bungsprojekt    12.02.2004
' Version 1.5 fr Georg Fischer
' Version 1.6 fr Atlas Copco
' Version 1.7 fr (Allgemein)
' Version 2.0 fr (Allgemein) Freeware Version
' Version 2.2.2 Dateiname aus ini Datei lesen und Dateiendung CSV + Format Nenn / Abw getauscht.
' Version speziell fr Firma Fastner 01.09.2006 T.Bach ( dfx Format mit reinen Messwerten.)
' Version gendert fr Fa. Grammer AG am 20.12.2006
'
'FindWindow dient der berprfung ob PC-DMIS gestartet ist
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" _
    (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Long

Sub Main()

Dim PCD_Obj As PCDLRN.Application
Dim PCD_PP As PCDLRN.PartProgram
Dim PCD_PPS As PCDLRN.PartPrograms
Dim PCD_CMDS As PCDLRN.Commands
Dim PCD_CMD As PCDLRN.Command
Dim PCD_Comment As PCDLRN.Comment
Dim PCD_Dimen As PCDLRN.DimensionCmd
Const ClaNa = "WilcoxAssociatesIncPC-DMISWndClass"

Dim MProgName As String
Dim MProgPfad As String
Dim Datei As String
Dim dn As Integer
Dim NR As Integer
Dim eOutputMode As String
Dim PRUEFNR As String
Dim PRUEFER As String
Dim Datenstring As String

' Command Automation Abfrage
Dim CommandName As String
Dim Automode As Integer
 If Command = "/a" Or Command = "/A" Then
   CommandName = Mid(Command, 2)
   Automode = 1
 Else
   Automode = 0
 End If

'berprfung ob PC-DMIS aktiv ist
If FindWindow(ClaNa, 0&) Then
    Set PCD_Obj = GetObject("", "PCDLRN.Application")
Else
     MsgBox ("PC-DMIS mu gestartet werden")
     End
End If
    
'berprfung ob Teileprogramm aktiv ist
    
On Error Resume Next
Set PCD_PP = PCD_Obj.ActivePartProgram
If PCD_PP = "Nothing" Then
    MsgBox ("Teileprogramm mu aktiv sein")
    End
End If
        
Set PCD_PPS = PCD_Obj.PartPrograms
Set PCD_PP = PCD_Obj.ActivePartProgram
Set PCD_CMDS = PCD_PP.Commands

'MProgName = "Test_01"        'Fester Dateiname nur fr GeorgFIscher
'MProgPfad = "C:\Messdaten\"  'Fester Pfadname nur fr GeorgFischer
MProgName = PCD_PP.PartName
MProgPfad = App.Path & "\"

  Datei = MProgPfad & MProgName & ".csv"
    
     If Automode = 0 Then
      FrageMB = MsgBox("Soll die Datei " & Datei & " mit den aktuellen Messdaten erzeugt werden?", vbYesNo)
      If FrageMB = vbNo Then
       End
      End If
     End If
 
 ' Formular mit Fortschrittsbalken anzeigen
   frm_GoASCII.Show
   frm_GoASCII.ProgressBar1.Min = 0
   frm_GoASCII.ProgressBar1.Max = 100
   frm_GoASCII.ProgressBar1.Value = 0
       
   'Kommentare aus PC-DMIS Messprogramm einlesen
'    For Each PCD_CMD In PCD_CMDS
'        If PCD_CMD.IsComment Then
'            Set PCD_CommentCMD = PCD_CMD.CommentCommand
'            If PCD_CommentCMD.CommentType = PCD_COMMENT_INPUT Then
'                CommentName = PCD_CommentCMD.Comment
'
'                Select Case CommentName
'
'                    Case "PRUEFER"
'
'                        TrimText = Trim(PCD_CommentCMD.Input)
'                        PRUEFER = TrimText
'
'                    Case "PRUEFLOSNUMMER"
'
'                        TrimText = Trim(PCD_CommentCMD.Input)
'                        PRUEFNR = TrimText
'
'                    End Select
'
'                End If
'         End If
'
'    Next PCD_CMD

'Test ob einlesen der Kommentare funktioniert
'MsgBox (PRUEFER)
'MsgBox (AUFTRAGSNUMMER)
       

' Messwerte von PC DMIS lesen
    
        
        Dim Zeile As String
        Dim Aufgabe As String
        Dim Ist As String
        Dim Nenn As String
        Dim OTol As String
        Dim UTol As String
        Dim Dev As String
        Dim AusTol As String
        Dim Max As String
        Dim Min As String
        Dim Bonus As String
        Dim Pos As String
        Dim Nummer As Integer
        Dim ABM_ID As String
        Dim BezugsElement, Bezug_ID As String
        
        ' Datei im ASCII Format ffnen
         Open Datei For Append As #1
        ' Print #1, MProgName
        
        ' neu mit Kommentar Abfrage
'        If Not PRUEFER = "" Or PRUEFER = " " Then
'          Print #1, "Pruefer: " & PRUEFER
'        End If
'        If Not PRUEFNR = "" Or PRUEFNR = " " Then
'          Print #1, "Prueflosnummer: " & PRUEFNR
'        End If
                
        Nummer = 0              'Variable definieren, um Auswertungszeile in ASCII Datei hochzuzhlen
    
        Set PCD_CMDS = PCD_PP.Commands
  
            
        For Each PCD_CMD In PCD_CMDS
          eineposition = 0
            If PCD_CMD.IsDimension Then
                Set PCD_DimenCMD = PCD_CMD.DimensionCommand
                If (PCD_CMD.Type = DIMENSION_START_LOCATION) Or (PCD_CMD.Type = DIMENSION_TRUE_START_POSITION) Then
                    Pos = PCD_DimenCMD.ID
                    Aufgabe = PCD_DimenCMD.Feat1
                    'BezugsElement = PCD_CMD.DimInfoCommand.DimensionId
                    'MsgBox (BezugsElement)
                     eOutputMode = PCD_DimenCMD.OutputMode
                Else
                    Ist = Format$(PCD_DimenCMD.Measured, "0.###0")
                    Nenn = Format$(PCD_DimenCMD.NOMINAL, "0.###0")
                    OTol = Format$(PCD_DimenCMD.Plus, "0.###0")
                    UTol = Format$((PCD_DimenCMD.Minus), "0.###0")
                    Dev = Format$((PCD_DimenCMD.Deviation), "0.###0")
                    AusTol = Format$((PCD_DimenCMD.OutTol), "0.###0")

                    Select Case PCD_CMD.Type
                        
                            Case DIMENSION_X_LOCATION
                                    ABM_ID = "X"
                            Case DIMENSION_Y_LOCATION
                                    ABM_ID = "Y"
                            Case DIMENSION_Z_LOCATION
                                    ABM_ID = "Z"
                            Case DIMENSION_D_LOCATION
                                    ABM_ID = "D"
                            Case DIMENSION_R_LOCATION
                                    ABM_ID = "R"
                            Case DIMENSION_A_LOCATION
                                    ABM_ID = "W"
                            Case DIMENSION_L_LOCATION
                                    ABM_ID = "L"
                            Case DIMENSION_T_LOCATION
                                    ABM_ID = "T"
                            Case DIMENSION_V_LOCATION
                                    ABM_ID = "V"
                            Case DIMENSION_H_LOCATION
                                    ABM_ID = "H"
                            Case DIMENSION_PR_LOCATION
                                    ABM_ID = "PR"
                            Case DIMENSION_PA_LOCATION
                                    ABM_ID = "PA"
                            Case DIMENSION_PD_LOCATION
                                    ABM_ID = "PD"
                            Case DIMENSION_RT_LOCATION
                                    ABM_ID = "RT"
                            Case DIMENSION_S_LOCATION
                                    ABM_ID = "S"
                            Case DIMENSION_RS_LOCATION
                                    ABM_ID = "RS"
                             Case DIMENSION_M_LOCATION
                                    ABM_ID = "M"
                            Case DIMENSION_STRAIGHTNESS
                                    ABM_ID = "Geradheit"
                            Case DIMENSION_ROUNDNESS
                                    ABM_ID = "Rundheit"
                            Case DIMENSION_FLATNESS
                                    ABM_ID = "Ebenheit"
                            Case DIMENSION_PERPENDICULARITY
                                    ABM_ID = "Rechtwinkligkeit"
                            Case DIMENSION_PARALLELISM
                                    ABM_ID = "Paralellitt"
                            Case DIMENSION_PROFILE
                                    ABM_ID = "Profil"
                            Case DIMENSION_3D_DISTANCE
                                    ABM_ID = "Abstand"
                            Case DIMENSION_2D_DISTANCE
                                    ABM_ID = "Abstand"
                            Case DIMENSION_3D_ANGLE
                                    ABM_ID = "Winkel"
                            Case DIMENSION_2D_ANGLE
                                    ABM_ID = "Winkel"
                            Case DIMENSION_RUNOUT
                                    ABM_ID = "Rundlauf"
                            Case DIMENSION_CONCENTRICITY
                                    ABM_ID = "Konzentrizitt"
                            Case DIMENSION_ANGULARITY
                                    ABM_ID = "Neigung"
                            Case DIMENSION_KEYIN
                                    ABM_ID = "Tastatur"
                            Case DIMENSION_TRUE_X_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                    
                                    ABM_ID = "X"
                            Case DIMENSION_TRUE_Y_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                    
                                    ABM_ID = "Y"
                            Case DIMENSION_TRUE_Z_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                    
                                    ABM_ID = "Z"
                            Case DIMENSION_TRUE_DD_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                    
                                    ABM_ID = " (Bezug)"
                            Case DIMENSION_TRUE_D1_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                    
                                    ABM_ID = " (Bezug1)"
                            Case DIMENSION_TRUE_D2_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                    
                                    ABM_ID = " (Bezug2)"
                            Case DIMENSION_TRUE_D3_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                   
                                    ABM_ID = " (Bezug3)"
                            Case DIMENSION_TRUE_DF_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                   
                                    ABM_ID = " (Prf)"
                            Case DIMENSION_TRUE_PR_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                    
                                    ABM_ID = "PR"
                            Case DIMENSION_TRUE_PA_LOCATION
                                    eineposition = 1
                                    GoTo nichtauswerten
                                    
                                    ABM_ID = "PA"
                            Case DIMENSION_TRUE_DIAM_LOCATION
                                    eineposition = 1
                                    ABM_ID = "Position"
                                    

                    End Select
                   
                    Nummer = Nummer + 1
                    
                    If PCD_CMD.Type = DIMENSION_PROFILE Or PCD_CMD.Type = DIMENSION_RUNOUT _
                                                  Or PCD_CMD.Type = DIMENSION_STRAIGHTNESS _
                                                  Or PCD_CMD.Type = DIMENSION_FLATNESS _
                                                  Or PCD_CMD.Type = DIMENSION_ROUNDNESS _
                                                  Or PCD_CMD.Type = DIMENSION_2D_ANGLE _
                                                  Or PCD_CMD.Type = DIMENSION_3D_ANGLE _
                                                  Or PCD_CMD.Type = DIMENSION_PERPENDICULARITY _
                                                  Or PCD_CMD.Type = DIMENSION_PARALLELISM _
                                                  Or PCD_CMD.Type = DIMENSION_3D_DISTANCE _
                                                  Or PCD_CMD.Type = DIMENSION_2D_DISTANCE _
                                                  Or PCD_CMD.Type = DIMENSION_CONCENTRICITY _
                                                  Or PCD_CMD.Type = DIMENSION_COAXIALITY _
                                                  Or PCD_CMD.Type = DIMENSION_ANGULARITY _
                                                  Or PCD_CMD.Type = DIMENSION_SYMMETRY _
                                                  Or PCD_CMD.Type = DIMENSION_KEYIN _
                                                  Then
                                                  
                        Pos = PCD_DimenCMD.ID
                        Max = (PCD_DimenCMD.Max)
                        Min = (PCD_DimenCMD.Min)
                        eOutputMode = PCD_DimenCMD.OutputMode

                    End If
                    
         If eOutputMode = "3" Or eOutputMode = "1" Then ' "Keines" oder Protokoll in Auswertung ausgewhlt, dann nicht auswerten
               eOutputMode = "2"
               GoTo nichtauswerten
         End If
         
         If frm_GoASCII.ProgressBar1.Value < 100 Then
            frm_GoASCII.ProgressBar1.Value = frm_GoASCII.ProgressBar1.Value + 1
         Else
            frm_GoASCII.ProgressBar1.Value = 0
         End If


                                                
        ' Abmessung in CSV ASCII Datei speichern. Bei Pos Tol die ABW anstatt der IST Position
        If eineposition >= 1 Then
         Zeile = Dev & ";"
        Else
         Zeile = Ist & ";"
        End If
        Datenstring = Datenstring + Zeile
        ' ende ASCII Speichern
               End If
         End If
nichtauswerten:

    Next PCD_CMD
    
Dim VL As Integer
VL = Len(Datenstring)
Datenstring = Mid(Datenstring, 1, VL - 1)
                    
'ASCII Datei schreiben + schlieen
Print #1, Datenstring
Close #1
frm_GoASCII.ProgressBar1.Value = 100

If Automode = 0 Then
  MsgBox ("SPC CSV Datei " & Datei & " wurde erfolgreich erzeugt."), vbOKOnly
End If

End

End Sub
